import { SecurityContext, Sanitizer, createPlatformFactory, COMPILER_OPTIONS, platformCore, Injectable, NgModule, ApplicationModule, RendererFactory2, ErrorHandler, Optional, SkipSelf, NO_ERRORS_SCHEMA } from '@angular/core';
import { ɵplatformCoreDynamic } from '@angular/platform-browser-dynamic';
import { DOCUMENT, ViewportScroller, ɵNullViewportScroller, LocationStrategy, PlatformLocation } from '@angular/common';
import { ElementSchemaRegistry } from '@angular/compiler';
import { __extends, __awaiter, __generator, __values, __read, __spread } from 'tslib';
import { QMainWindow, QWidget, FlexLayout, QPushButton, QLabel, QCheckBox, QDial, QPixmap, QLineEdit, QPlainTextEdit, QRadioButton, QProgressBar, QScrollArea, QSpinBox, QComboBox } from '@nodegui/nodegui';
import phin from 'phin';
import { HttpBackend } from '@angular/common/http';
import { from } from 'rxjs';
import fetch from 'node-fetch';
import { DefaultUrlSerializer, RouterModule } from '@angular/router';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NodeguiElementSchemaRegistry = /** @class */ (function (_super) {
    __extends(NodeguiElementSchemaRegistry, _super);
    function NodeguiElementSchemaRegistry() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} tagName
     * @param {?} propName
     * @return {?}
     */
    NodeguiElementSchemaRegistry.prototype.hasProperty = /**
     * @param {?} tagName
     * @param {?} propName
     * @return {?}
     */
    function (tagName, propName) {
        return true;
    };
    /**
     * @param {?} tagName
     * @param {?} schemaMetas
     * @return {?}
     */
    NodeguiElementSchemaRegistry.prototype.hasElement = /**
     * @param {?} tagName
     * @param {?} schemaMetas
     * @return {?}
     */
    function (tagName, schemaMetas) {
        return true;
    };
    /**
     * @param {?} propName
     * @return {?}
     */
    NodeguiElementSchemaRegistry.prototype.getMappedPropName = /**
     * @param {?} propName
     * @return {?}
     */
    function (propName) {
        return propName;
    };
    /**
     * @return {?}
     */
    NodeguiElementSchemaRegistry.prototype.getDefaultComponentElementName = /**
     * @return {?}
     */
    function () {
        return 'ng-component';
    };
    /**
     * @param {?} tagName
     * @param {?} propName
     * @return {?}
     */
    NodeguiElementSchemaRegistry.prototype.securityContext = /**
     * @param {?} tagName
     * @param {?} propName
     * @return {?}
     */
    function (tagName, propName) {
        return SecurityContext.NONE;
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NodeguiElementSchemaRegistry.prototype.validateProperty = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        return { error: false };
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NodeguiElementSchemaRegistry.prototype.validateAttribute = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        return { error: false };
    };
    /**
     * @return {?}
     */
    NodeguiElementSchemaRegistry.prototype.allKnownElementNames = /**
     * @return {?}
     */
    function () {
        return [];
    };
    /**
     * @param {?} propName
     * @return {?}
     */
    NodeguiElementSchemaRegistry.prototype.normalizeAnimationStyleProperty = /**
     * @param {?} propName
     * @return {?}
     */
    function (propName) {
        return propName;
    };
    /**
     * @param {?} camelCaseProp
     * @param {?} userProvidedProp
     * @param {?} val
     * @return {?}
     */
    NodeguiElementSchemaRegistry.prototype.normalizeAnimationStyleValue = /**
     * @param {?} camelCaseProp
     * @param {?} userProvidedProp
     * @param {?} val
     * @return {?}
     */
    function (camelCaseProp, userProvidedProp, val) {
        return { error: null, value: val.toString() };
    };
    return NodeguiElementSchemaRegistry;
}(ElementSchemaRegistry));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NodeguiSanitizer = /** @class */ (function (_super) {
    __extends(NodeguiSanitizer, _super);
    function NodeguiSanitizer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} context
     * @param {?} value
     * @return {?}
     */
    NodeguiSanitizer.prototype.sanitize = /**
     * @param {?} context
     * @param {?} value
     * @return {?}
     */
    function (context, value) {
        return value;
    };
    return NodeguiSanitizer;
}(Sanitizer));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0 = {}, ɵ1 = {
    providers: [
        {
            provide: ElementSchemaRegistry,
            useClass: NodeguiElementSchemaRegistry,
            deps: []
        }
        // {
        //   provide: ResourceLoader,
        //   useClass: FileSystemResourceLoader,
        //   deps: []
        // }
    ]
};
/** @type {?} */
var platformNodeguiDynamic = createPlatformFactory(ɵplatformCoreDynamic, 'NodeguiDynamic', [
    { provide: DOCUMENT, useValue: ɵ0 },
    { provide: Sanitizer, useClass: NodeguiSanitizer, deps: [] },
    {
        provide: COMPILER_OPTIONS,
        useValue: ɵ1,
        multi: true
    }
]);

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0$1 = {}, ɵ1$1 = {
    providers: [
        {
            provide: ElementSchemaRegistry,
            useClass: NodeguiElementSchemaRegistry,
            deps: []
        }
    ]
};
/** @type {?} */
var platformNodeguiStatic = createPlatformFactory(platformCore, 'NodeguiStatic', [
    { provide: DOCUMENT, useValue: ɵ0$1 },
    { provide: Sanitizer, useClass: NodeguiSanitizer, deps: [] },
    {
        provide: COMPILER_OPTIONS,
        useValue: ɵ1$1,
        multi: true
    }
]);

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var QWindowService = /** @class */ (function () {
    function QWindowService() {
        this.window = new QMainWindow();
        this.centralWidget = new QWidget();
        this.centralWidget.setObjectName('myroot');
    }
    QWindowService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    QWindowService.ctorParameters = function () { return []; };
    return QWindowService;
}());
if (false) {
    /** @type {?} */
    QWindowService.prototype.window;
    /** @type {?} */
    QWindowService.prototype.rootLayout;
    /** @type {?} */
    QWindowService.prototype.centralWidget;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgWindow = /** @class */ (function (_super) {
    __extends(NgWindow, _super);
    function NgWindow() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgWindow.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        this.addWidget(newChild);
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgWindow.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) { };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgWindow.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'title':
                this.parent.setWindowTitle(value);
                break;
            case 'id':
                this.parent.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgWindow.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgWindow.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgWindow.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgWindow.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgWindow.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgWindow.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgWindow.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgWindow.nodeName = 'window';
    return NgWindow;
}(FlexLayout));
if (false) {
    /** @type {?} */
    NgWindow.nodeName;
    /** @type {?} */
    NgWindow.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TextField = /** @class */ (function (_super) {
    __extends(TextField, _super);
    function TextField(value) {
        var _this = _super.call(this) || this;
        _this.value = value;
        return _this;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    TextField.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.parent.setText(value);
    };
    return TextField;
}(QWidget));
if (false) {
    /** @type {?} */
    TextField.prototype.parent;
    /** @type {?} */
    TextField.prototype.value;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgButton = /** @class */ (function (_super) {
    __extends(NgButton, _super);
    function NgButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgButton.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        if (newChild instanceof TextField) {
            newChild.parent = this;
            this.setText(newChild.value);
        }
        else {
            console.warn('Button may be appendChild only TextField');
        }
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgButton.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) { };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgButton.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgButton.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        switch (name) {
            case 'enabled':
                this.setEnabled((/** @type {?} */ (value)));
                break;
            case 'flat':
                this.setFlat((/** @type {?} */ (value)));
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgButton.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgButton.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.setText(value);
    };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgButton.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgButton.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgButton.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgButton.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgButton.nodeName = 'button';
    return NgButton;
}(QPushButton));
if (false) {
    /** @type {?} */
    NgButton.nodeName;
    /** @type {?} */
    NgButton.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgText = /** @class */ (function (_super) {
    __extends(NgText, _super);
    function NgText() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgText.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        if (newChild instanceof TextField) {
            newChild.parent = this;
            this.setText(newChild.value);
        }
        else {
            console.warn('Text may be appendChild only TextField');
        }
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgText.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) { };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgText.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgText.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        switch (name) {
            case 'style':
                this.setStyleSheet(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgText.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgText.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.setText(value);
    };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgText.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgText.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgText.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgText.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgText.nodeName = 'text';
    return NgText;
}(QLabel));
if (false) {
    /** @type {?} */
    NgText.nodeName;
    /** @type {?} */
    NgText.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgView = /** @class */ (function (_super) {
    __extends(NgView, _super);
    function NgView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgView.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        if (!newChild) {
            return;
        }
        if (!this.layout) {
            this.createLayout();
        }
        this.layout.addWidget(newChild);
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgView.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) {
        if (!newChild) {
            return;
        }
        if (!this.layout) {
            this.createLayout();
        }
        ((/** @type {?} */ (this.layout))).insertChildBefore(newChild, this);
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgView.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        oldChild.hide(); // it's necessary that there's no overlapping of widgets when removing
        ((/** @type {?} */ (this.layout))).removeWidget(oldChild);
    };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgView.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgView.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        this.setProperty(name, value);
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgView.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgView.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgView.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgView.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgView.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    /**
     * @private
     * @return {?}
     */
    NgView.prototype.createLayout = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var flexLayout = new FlexLayout();
        flexLayout.setFlexNode(this.getFlexNode());
        this.setLayout(flexLayout);
        this.layout = flexLayout;
    };
    NgView.nodeName = 'view';
    return NgView;
}(QWidget));
if (false) {
    /** @type {?} */
    NgView.nodeName;
    /** @type {?} */
    NgView.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgCheckbox = /** @class */ (function (_super) {
    __extends(NgCheckbox, _super);
    function NgCheckbox() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgCheckbox.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        if (newChild instanceof TextField) {
            newChild.parent = this;
            this.setText(newChild.value);
        }
        else {
            console.warn('checkbox may be appendChild only TextField');
        }
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgCheckbox.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) { };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgCheckbox.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgCheckbox.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        this.setProperty(name, value);
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgCheckbox.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgCheckbox.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.setText(value);
    };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgCheckbox.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgCheckbox.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgCheckbox.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgCheckbox.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgCheckbox.nodeName = 'checkbox';
    return NgCheckbox;
}(QCheckBox));
if (false) {
    /** @type {?} */
    NgCheckbox.nodeName;
    /** @type {?} */
    NgCheckbox.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgDial = /** @class */ (function (_super) {
    __extends(NgDial, _super);
    function NgDial() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgDial.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        console.warn('dial do not have append child');
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgDial.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) { };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgDial.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgDial.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        this.setProperty(name, value);
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgDial.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgDial.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) { };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgDial.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgDial.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgDial.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgDial.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgDial.nodeName = 'dial';
    return NgDial;
}(QDial));
if (false) {
    /** @type {?} */
    NgDial.nodeName;
    /** @type {?} */
    NgDial.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgImage = /** @class */ (function (_super) {
    __extends(NgImage, _super);
    function NgImage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgImage.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        console.warn('image not supported appendChild');
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgImage.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) { };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgImage.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgImage.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        var _this = this;
        switch (name) {
            case 'src':
                if (!value) {
                    return;
                }
                getLoadedPixmap((/** @type {?} */ (value)))
                    .then((/**
                 * @param {?} pixmap
                 * @return {?}
                 */
                function (pixmap) { return _this.setPixmap(pixmap); }))
                    .catch(console.warn);
                // TODO: not set current aspect size
                // const size = this.size();
                // this.scalePixmap(size.width, size.height);
                break;
            case 'buffer':
                /** @type {?} */
                var pixMap = new QPixmap();
                pixMap.loadFromData((/** @type {?} */ (value)));
                this.setPixmap(pixMap);
                break;
            case 'aspectRatioMode':
                this.setAspectRatioMode((/** @type {?} */ (value)));
                break;
            default:
                this.setProperty(name, (/** @type {?} */ (value)));
                break;
        }
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgImage.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgImage.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.setText(value);
    };
    /**
     * @param {?} mode
     * @return {?}
     */
    NgImage.prototype.setAspectRatioMode = /**
     * @param {?} mode
     * @return {?}
     */
    function (mode) {
        this.aspectRatioMode = mode;
    };
    /**
     * @param {?} width
     * @param {?} height
     * @return {?}
     */
    NgImage.prototype.scalePixmap = /**
     * @param {?} width
     * @param {?} height
     * @return {?}
     */
    function (width, height) {
        if (this.originalPixmap) {
            return _super.prototype.setPixmap.call(this, this.originalPixmap.scaled(width, height, this.aspectRatioMode));
        }
    };
    /**
     * @param {?} pixmap
     * @return {?}
     */
    NgImage.prototype.setPixmap = /**
     * @param {?} pixmap
     * @return {?}
     */
    function (pixmap) {
        _super.prototype.setPixmap.call(this, pixmap);
        this.originalPixmap = pixmap;
    };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgImage.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgImage.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgImage.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgImage.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgImage.nodeName = 'image';
    return NgImage;
}(QLabel));
if (false) {
    /** @type {?} */
    NgImage.nodeName;
    /** @type {?} */
    NgImage.prototype.parent;
    /** @type {?} */
    NgImage.prototype.originalPixmap;
    /** @type {?} */
    NgImage.prototype.aspectRatioMode;
}
/**
 * @param {?} imageUrlOrPath
 * @return {?}
 * @this {*}
 */
function getLoadedPixmap(imageUrlOrPath) {
    return __awaiter(this, void 0, void 0, function () {
        var pixMap, res, imageBuffer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    pixMap = new QPixmap();
                    if (!isValidUrl(imageUrlOrPath)) return [3 /*break*/, 2];
                    return [4 /*yield*/, phin(imageUrlOrPath)];
                case 1:
                    res = _a.sent();
                    imageBuffer = Buffer.from(res.body);
                    pixMap.loadFromData(imageBuffer);
                    return [3 /*break*/, 3];
                case 2:
                    pixMap.load(imageUrlOrPath);
                    _a.label = 3;
                case 3: return [2 /*return*/, pixMap];
            }
        });
    });
}
/**
 * @param {?} str
 * @return {?}
 */
function isValidUrl(str) {
    try {
        // tslint:disable-next-line:no-unused-expression
        new URL(str);
        return true;
    }
    catch (_) {
        return false;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgLineEdit = /** @class */ (function (_super) {
    __extends(NgLineEdit, _super);
    function NgLineEdit() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgLineEdit.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgLineEdit.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) { };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgLineEdit.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgLineEdit.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        switch (name) {
            case 'text':
                value ? this.setText((/** @type {?} */ (value))) : this.clear();
                break;
            default:
                this.setProperty(name, value);
                break;
        }
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgLineEdit.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgLineEdit.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.setText(value);
    };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgLineEdit.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgLineEdit.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgLineEdit.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgLineEdit.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgLineEdit.nodeName = 'linedit';
    return NgLineEdit;
}(QLineEdit));
if (false) {
    /** @type {?} */
    NgLineEdit.nodeName;
    /** @type {?} */
    NgLineEdit.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgPlainTextEdit = /** @class */ (function (_super) {
    __extends(NgPlainTextEdit, _super);
    function NgPlainTextEdit() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgPlainTextEdit.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        console.warn('plaintextedit do not have append child');
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgPlainTextEdit.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) { };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgPlainTextEdit.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgPlainTextEdit.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        switch (name) {
            case 'text':
                value ? this.setPlainText((/** @type {?} */ (value))) : this.clear();
                break;
            default:
                this.setProperty(name, value);
                break;
        }
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgPlainTextEdit.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgPlainTextEdit.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgPlainTextEdit.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgPlainTextEdit.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgPlainTextEdit.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgPlainTextEdit.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgPlainTextEdit.nodeName = 'plaintextedit';
    return NgPlainTextEdit;
}(QPlainTextEdit));
if (false) {
    /** @type {?} */
    NgPlainTextEdit.nodeName;
    /** @type {?} */
    NgPlainTextEdit.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgRadioButton = /** @class */ (function (_super) {
    __extends(NgRadioButton, _super);
    function NgRadioButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgRadioButton.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        console.warn('radiobutton do not have append child');
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgRadioButton.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) { };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgRadioButton.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgRadioButton.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        this.setProperty(name, value);
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgRadioButton.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgRadioButton.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.setText(value);
    };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgRadioButton.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgRadioButton.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgRadioButton.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgRadioButton.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgRadioButton.nodeName = 'radiobutton';
    return NgRadioButton;
}(QRadioButton));
if (false) {
    /** @type {?} */
    NgRadioButton.nodeName;
    /** @type {?} */
    NgRadioButton.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgProgressBar = /** @class */ (function (_super) {
    __extends(NgProgressBar, _super);
    function NgProgressBar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgProgressBar.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        console.warn('progressbar do not have append child');
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgProgressBar.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) { };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgProgressBar.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) { };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgProgressBar.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        this.setProperty(name, value);
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgProgressBar.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgProgressBar.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        _super.prototype.setValue.call(this, value);
    };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgProgressBar.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgProgressBar.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgProgressBar.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgProgressBar.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgProgressBar.nodeName = 'progressbar';
    return NgProgressBar;
}(QProgressBar));
if (false) {
    /** @type {?} */
    NgProgressBar.nodeName;
    /** @type {?} */
    NgProgressBar.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgScrollArea = /** @class */ (function (_super) {
    __extends(NgScrollArea, _super);
    function NgScrollArea() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgScrollArea.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        if (this.contentWidget) {
            console.warn('ScrollView cant have more than one child node');
            return;
        }
        this.setWidget(newChild);
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgScrollArea.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgScrollArea.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgScrollArea.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        this.setProperty(name, value);
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgScrollArea.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgScrollArea.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) { };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgScrollArea.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgScrollArea.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        /** @type {?} */
        var removedChild = this.takeWidget();
        if (removedChild) {
            removedChild.close();
        }
        oldChild.close();
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgScrollArea.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgScrollArea.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgScrollArea.nodeName = 'scrollarea';
    return NgScrollArea;
}(QScrollArea));
if (false) {
    /** @type {?} */
    NgScrollArea.nodeName;
    /** @type {?} */
    NgScrollArea.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function Range() { }
if (false) {
    /** @type {?} */
    Range.prototype.minimum;
    /** @type {?} */
    Range.prototype.maximum;
}
var NgSpinnBox = /** @class */ (function (_super) {
    __extends(NgSpinnBox, _super);
    function NgSpinnBox() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgSpinnBox.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgSpinnBox.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) { };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgSpinnBox.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgSpinnBox.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        switch (name) {
            case 'range':
                this.setRange(((/** @type {?} */ (value))).minimum, ((/** @type {?} */ (value))).maximum);
                break;
            default:
                this.setProperty(name, (/** @type {?} */ (value)));
                break;
        }
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgSpinnBox.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgSpinnBox.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        _super.prototype.setValue.call(this, value);
    };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgSpinnBox.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgSpinnBox.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgSpinnBox.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgSpinnBox.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgSpinnBox.nodeName = 'spinbox';
    return NgSpinnBox;
}(QSpinBox));
if (false) {
    /** @type {?} */
    NgSpinnBox.nodeName;
    /** @type {?} */
    NgSpinnBox.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ComboBoxItem() { }
if (false) {
    /** @type {?} */
    ComboBoxItem.prototype.text;
    /** @type {?|undefined} */
    ComboBoxItem.prototype.icon;
    /** @type {?|undefined} */
    ComboBoxItem.prototype.userData;
}
var NgCombobox = /** @class */ (function (_super) {
    __extends(NgCombobox, _super);
    function NgCombobox() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} newChild
     * @return {?}
     */
    NgCombobox.prototype.appendChild = /**
     * @param {?} newChild
     * @return {?}
     */
    function (newChild) {
        console.warn('combobox do not have append child');
    };
    /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    NgCombobox.prototype.insertBefore = /**
     * @param {?} newChild
     * @param {?} refChild
     * @return {?}
     */
    function (newChild, refChild) { };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NgCombobox.prototype.setNgAttribute = /**
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (name, value, namespace) {
        switch (name) {
            case 'id':
                this.setObjectName(value);
                break;
            default:
                break;
        }
    };
    /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NgCombobox.prototype.setNgProperty = /**
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (name, value) {
        var _this = this;
        if (name === 'items') {
            this.clear();
            value.forEach((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                _this.addItem(item.icon, item.text, item.userData);
            }));
        }
        this.setProperty(name, value);
    };
    /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NgCombobox.prototype.setStyle = /**
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (style, value, flags) {
        this.setInlineStyle(style + ":" + value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NgCombobox.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NgCombobox.prototype.removeAttribute = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} oldChild
     * @return {?}
     */
    NgCombobox.prototype.removeChild = /**
     * @param {?} oldChild
     * @return {?}
     */
    function (oldChild) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} name
     * @return {?}
     */
    NgCombobox.prototype.removeClass = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NgCombobox.prototype.removeStyle = /**
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (style, flags) {
        throw new Error('Method not implemented.');
    };
    NgCombobox.nodeName = 'combobox';
    return NgCombobox;
}(QComboBox));
if (false) {
    /** @type {?} */
    NgCombobox.nodeName;
    /** @type {?} */
    NgCombobox.prototype.parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ComponentsMap = /** @class */ (function () {
    function ComponentsMap() {
        this.map = new Map();
        this.map.set(NgButton.nodeName, NgButton);
        this.map.set(NgCheckbox.nodeName, NgCheckbox);
        this.map.set(NgCombobox.nodeName, NgCombobox);
        this.map.set(NgDial.nodeName, NgDial);
        this.map.set(NgImage.nodeName, NgImage);
        this.map.set(NgLineEdit.nodeName, NgLineEdit);
        this.map.set(NgPlainTextEdit.nodeName, NgPlainTextEdit);
        this.map.set(NgProgressBar.nodeName, NgProgressBar);
        this.map.set(NgRadioButton.nodeName, NgRadioButton);
        this.map.set(NgScrollArea.nodeName, NgScrollArea);
        this.map.set(NgSpinnBox.nodeName, NgSpinnBox);
        this.map.set(NgText.nodeName, NgText);
        this.map.set(NgView.nodeName, NgView);
        this.map.set(NgWindow.nodeName, NgWindow);
    }
    ComponentsMap.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ComponentsMap.ctorParameters = function () { return []; };
    return ComponentsMap;
}());
if (false) {
    /** @type {?} */
    ComponentsMap.prototype.map;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ElementReference() { }
if (false) {
    /** @type {?} */
    ElementReference.prototype.previous;
    /** @type {?} */
    ElementReference.prototype.next;
}
var NodeguiRendererFactory = /** @class */ (function () {
    function NodeguiRendererFactory(windowService, components) {
        this.windowService = windowService;
        this.renderer = new NodeguiRenderer(windowService, components);
    }
    /**
     * @return {?}
     */
    NodeguiRendererFactory.prototype.end = /**
     * @return {?}
     */
    function () {
        this.windowService.window.show();
    };
    /**
     * @param {?} hostElement
     * @param {?} type
     * @return {?}
     */
    NodeguiRendererFactory.prototype.createRenderer = /**
     * @param {?} hostElement
     * @param {?} type
     * @return {?}
     */
    function (hostElement, type) {
        if (type) {
            hostElement.setStyleSheet(type.styles);
        }
        return this.renderer;
    };
    NodeguiRendererFactory.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NodeguiRendererFactory.ctorParameters = function () { return [
        { type: QWindowService },
        { type: ComponentsMap }
    ]; };
    return NodeguiRendererFactory;
}());
if (false) {
    /**
     * @type {?}
     * @protected
     */
    NodeguiRendererFactory.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    NodeguiRendererFactory.prototype.windowService;
}
var NodeguiRenderer = /** @class */ (function () {
    function NodeguiRenderer(window, components) {
        this.window = window;
        this.componentsMap = components.map;
    }
    /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NodeguiRenderer.prototype.createElement = /**
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (name, namespace) {
        /** @type {?} */
        var Component = this.componentsMap.get(name);
        if (Component) {
            return new Component();
        }
        else {
            /** @type {?} */
            var widget = new NgView();
            widget.setObjectName(name);
            return widget;
        }
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NodeguiRenderer.prototype.createText = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return new TextField(value);
    };
    /**
     * @return {?}
     */
    NodeguiRenderer.prototype.selectRootElement = /**
     * @return {?}
     */
    function () {
        return this.window.window;
    };
    /**
     * @param {?} el
     * @param {?} name
     * @return {?}
     */
    NodeguiRenderer.prototype.addClass = /**
     * @param {?} el
     * @param {?} name
     * @return {?}
     */
    function (el, name) {
        console.log(el, name);
    };
    /**
     * @param {?} parent
     * @param {?} newChild
     * @return {?}
     */
    NodeguiRenderer.prototype.appendChild = /**
     * @param {?} parent
     * @param {?} newChild
     * @return {?}
     */
    function (parent, newChild) {
        if (newChild) {
            if (parent instanceof QMainWindow && newChild instanceof NgWindow) {
                newChild.parent = parent;
                this.window.centralWidget.setLayout(newChild);
                this.window.window.setCentralWidget(this.window.centralWidget);
            }
            else {
                parent.appendChild(newChild);
            }
        }
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NodeguiRenderer.prototype.createComment = /**
     * @param {?} value
     * @return {?}
     */
    function (value) { };
    /**
     * @return {?}
     */
    NodeguiRenderer.prototype.destroy = /**
     * @return {?}
     */
    function () { };
    /**
     * @param {?} parent
     * @param {?} newChild
     * @param {?} __2
     * @return {?}
     */
    NodeguiRenderer.prototype.insertBefore = /**
     * @param {?} parent
     * @param {?} newChild
     * @param {?} __2
     * @return {?}
     */
    function (parent, newChild, _a) {
        var previous = _a.previous, next = _a.next;
        newChild.parent = previous;
        previous.insertBefore(newChild, next);
    };
    /**
     * @param {?} parent
     * @param {?} oldChild
     * @return {?}
     */
    NodeguiRenderer.prototype.removeChild = /**
     * @param {?} parent
     * @param {?} oldChild
     * @return {?}
     */
    function (parent, oldChild) {
        parent.removeChild(oldChild);
    };
    /**
     * @param {?} target
     * @param {?} eventName
     * @param {?} callback
     * @return {?}
     */
    NodeguiRenderer.prototype.listen = /**
     * @param {?} target
     * @param {?} eventName
     * @param {?} callback
     * @return {?}
     */
    function (target, eventName, callback) {
        /** @type {?} */
        var callbackFunc = (/**
         * @param {?} e
         * @return {?}
         */
        function (e) { return callback.call(target, e); });
        target.addEventListener(eventName, callbackFunc);
        return (/**
         * @return {?}
         */
        function () { return target.removeEventListener(eventName, callbackFunc); });
    };
    /**
     * @param {?} node
     * @return {?}
     */
    NodeguiRenderer.prototype.nextSibling = /**
     * @param {?} node
     * @return {?}
     */
    function (node) {
        return {
            previous: node,
            next: node.nextSibling
        };
    };
    /**
     * @param {?} node
     * @return {?}
     */
    NodeguiRenderer.prototype.parentNode = /**
     * @param {?} node
     * @return {?}
     */
    function (node) {
        return node.parent ? node.parent : node;
    };
    /**
     * @param {?} el
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    NodeguiRenderer.prototype.removeAttribute = /**
     * @param {?} el
     * @param {?} name
     * @param {?=} namespace
     * @return {?}
     */
    function (el, name, namespace) {
        el.removeAttribute(name, namespace);
    };
    /**
     * @param {?} el
     * @param {?} name
     * @return {?}
     */
    NodeguiRenderer.prototype.removeClass = /**
     * @param {?} el
     * @param {?} name
     * @return {?}
     */
    function (el, name) {
        el.removeClass(name);
    };
    /**
     * @param {?} el
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    NodeguiRenderer.prototype.removeStyle = /**
     * @param {?} el
     * @param {?} style
     * @param {?=} flags
     * @return {?}
     */
    function (el, style, flags) {
        el.removeStyle(style, flags);
    };
    /**
     * @param {?} el
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    NodeguiRenderer.prototype.setAttribute = /**
     * @param {?} el
     * @param {?} name
     * @param {?} value
     * @param {?=} namespace
     * @return {?}
     */
    function (el, name, value, namespace) {
        if (el instanceof QMainWindow) {
            console.log(QMainWindow.name + " name = " + value);
        }
        else {
            el.setNgAttribute(name, value, namespace);
        }
    };
    /**
     * @param {?} el
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    NodeguiRenderer.prototype.setProperty = /**
     * @param {?} el
     * @param {?} name
     * @param {?} value
     * @return {?}
     */
    function (el, name, value) {
        el.setNgProperty(name, value);
    };
    /**
     * @param {?} el
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    NodeguiRenderer.prototype.setStyle = /**
     * @param {?} el
     * @param {?} style
     * @param {?} value
     * @param {?=} flags
     * @return {?}
     */
    function (el, style, value, flags) {
        console.log('setStyle', style);
        el.setStyle(style, value, flags);
    };
    /**
     * @param {?} node
     * @param {?} value
     * @return {?}
     */
    NodeguiRenderer.prototype.setValue = /**
     * @param {?} node
     * @param {?} value
     * @return {?}
     */
    function (node, value) {
        node.setValue(value);
    };
    return NodeguiRenderer;
}());
if (false) {
    /** @type {?} */
    NodeguiRenderer.prototype.data;
    /** @type {?} */
    NodeguiRenderer.prototype.componentsMap;
    /** @type {?} */
    NodeguiRenderer.prototype.destroyNode;
    /**
     * @type {?}
     * @private
     */
    NodeguiRenderer.prototype.window;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NodeguiErrorHandler = /** @class */ (function () {
    function NodeguiErrorHandler() {
    }
    /**
     * @param {?} error
     * @return {?}
     */
    NodeguiErrorHandler.prototype.handleError = /**
     * @param {?} error
     * @return {?}
     */
    function (error) {
        console.error(error.message, error.stack);
    };
    NodeguiErrorHandler.decorators = [
        { type: Injectable }
    ];
    return NodeguiErrorHandler;
}());
var NodeguiLibModule = /** @class */ (function () {
    function NodeguiLibModule() {
    }
    NodeguiLibModule.decorators = [
        { type: NgModule, args: [{
                    exports: [ApplicationModule],
                    providers: [
                        QWindowService,
                        ComponentsMap,
                        {
                            provide: RendererFactory2,
                            useClass: NodeguiRendererFactory,
                            deps: [QWindowService, ComponentsMap]
                        },
                        { provide: ErrorHandler, useClass: NodeguiErrorHandler },
                        { provide: ViewportScroller, useClass: ɵNullViewportScroller }
                    ]
                },] }
    ];
    return NodeguiLibModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} strMap
 * @return {?}
 */
function strMapToObj(strMap) {
    var e_1, _a;
    /** @type {?} */
    var obj = Object.create(null);
    try {
        for (var _b = __values(strMap.headers), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 2), k = _d[0], v = _d[1];
            obj[k] = v;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return obj;
}
var HttpFetchBackend = /** @class */ (function (_super) {
    __extends(HttpFetchBackend, _super);
    function HttpFetchBackend() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param {?} req
     * @return {?}
     */
    HttpFetchBackend.prototype.handle = /**
     * @param {?} req
     * @return {?}
     */
    function (req) {
        return from(fetch(req.url, {
            method: req.method,
            cache: 'no-cache',
            credentials: req.withCredentials ? 'same-origin' : undefined,
            headers: req.headers ? strMapToObj(req.headers) : undefined,
            body: req.body ? JSON.stringify(req.body) : undefined
        }).then((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return res.json(); })));
    };
    return HttpFetchBackend;
}(HttpBackend));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NodeGuiLocationStrategy = /** @class */ (function (_super) {
    __extends(NodeGuiLocationStrategy, _super);
    function NodeGuiLocationStrategy() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.popStateCallbacks = new Array();
        return _this;
    }
    /**
     * @param {?=} includeHash
     * @return {?}
     */
    NodeGuiLocationStrategy.prototype.path = /**
     * @param {?=} includeHash
     * @return {?}
     */
    function (includeHash) {
        return '/';
    };
    /**
     * @param {?} internal
     * @return {?}
     */
    NodeGuiLocationStrategy.prototype.prepareExternalUrl = /**
     * @param {?} internal
     * @return {?}
     */
    function (internal) {
        return internal;
    };
    /**
     * @param {?} state
     * @param {?} title
     * @param {?} url
     * @param {?} queryParams
     * @return {?}
     */
    NodeGuiLocationStrategy.prototype.pushState = /**
     * @param {?} state
     * @param {?} title
     * @param {?} url
     * @param {?} queryParams
     * @return {?}
     */
    function (state, title, url, queryParams) {
        /** @type {?} */
        var urlSerializer = new DefaultUrlSerializer();
        this.currentUrlTree = urlSerializer.parse(url);
        /** @type {?} */
        var urlTreeRoot = this.currentUrlTree.root;
    };
    /**
     * @param {?} state
     * @param {?} title
     * @param {?} url
     * @param {?} queryParams
     * @return {?}
     */
    NodeGuiLocationStrategy.prototype.replaceState = /**
     * @param {?} state
     * @param {?} title
     * @param {?} url
     * @param {?} queryParams
     * @return {?}
     */
    function (state, title, url, queryParams) { };
    /**
     * @return {?}
     */
    NodeGuiLocationStrategy.prototype.forward = /**
     * @return {?}
     */
    function () {
        throw new Error('Method not implemented.');
    };
    /**
     * @return {?}
     */
    NodeGuiLocationStrategy.prototype.back = /**
     * @return {?}
     */
    function () {
        throw new Error('Method not implemented.');
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NodeGuiLocationStrategy.prototype.onPopState = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.popStateCallbacks.push(fn);
    };
    /**
     * @return {?}
     */
    NodeGuiLocationStrategy.prototype.getBaseHref = /**
     * @return {?}
     */
    function () {
        return '';
    };
    NodeGuiLocationStrategy.decorators = [
        { type: Injectable }
    ];
    return NodeGuiLocationStrategy;
}(LocationStrategy));
if (false) {
    /**
     * @type {?}
     * @private
     */
    NodeGuiLocationStrategy.prototype.popStateCallbacks;
    /**
     * @type {?}
     * @private
     */
    NodeGuiLocationStrategy.prototype.currentUrlTree;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NodeguiPlatformLocation = /** @class */ (function (_super) {
    __extends(NodeguiPlatformLocation, _super);
    function NodeguiPlatformLocation(locationStrategy) {
        var _this = _super.call(this) || this;
        _this.locationStrategy = locationStrategy;
        return _this;
    }
    /**
     * @return {?}
     */
    NodeguiPlatformLocation.prototype.getState = /**
     * @return {?}
     */
    function () {
        return undefined;
    };
    /**
     * @return {?}
     */
    NodeguiPlatformLocation.prototype.getBaseHrefFromDOM = /**
     * @return {?}
     */
    function () {
        return '/';
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NodeguiPlatformLocation.prototype.onPopState = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.locationStrategy.onPopState(fn);
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NodeguiPlatformLocation.prototype.onHashChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    Object.defineProperty(NodeguiPlatformLocation.prototype, "search", {
        get: /**
         * @return {?}
         */
        function () {
            return '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NodeguiPlatformLocation.prototype, "hash", {
        get: /**
         * @return {?}
         */
        function () {
            return '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NodeguiPlatformLocation.prototype, "pathname", {
        get: /**
         * @return {?}
         */
        function () {
            return this.locationStrategy.path();
        },
        set: /**
         * @param {?} newPath
         * @return {?}
         */
        function (newPath) {
            throw new Error('NodeguiPlatformLocation set pathname - not implemented');
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} state
     * @param {?} title
     * @param {?} url
     * @return {?}
     */
    NodeguiPlatformLocation.prototype.pushState = /**
     * @param {?} state
     * @param {?} title
     * @param {?} url
     * @return {?}
     */
    function (state, title, url) {
        this.locationStrategy.pushState(state, title, url, null);
    };
    /**
     * @param {?} state
     * @param {?} title
     * @param {?} url
     * @return {?}
     */
    NodeguiPlatformLocation.prototype.replaceState = /**
     * @param {?} state
     * @param {?} title
     * @param {?} url
     * @return {?}
     */
    function (state, title, url) {
        this.locationStrategy.replaceState(state, title, url, null);
    };
    /**
     * @return {?}
     */
    NodeguiPlatformLocation.prototype.forward = /**
     * @return {?}
     */
    function () {
        throw new Error('NodeguiPlatformLocation.forward() - not implemented');
    };
    /**
     * @return {?}
     */
    NodeguiPlatformLocation.prototype.back = /**
     * @return {?}
     */
    function () {
        this.locationStrategy.back();
    };
    NodeguiPlatformLocation.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NodeguiPlatformLocation.ctorParameters = function () { return [
        { type: NodeGuiLocationStrategy }
    ]; };
    return NodeguiPlatformLocation;
}(PlatformLocation));
if (false) {
    /** @type {?} */
    NodeguiPlatformLocation.prototype.hostname;
    /** @type {?} */
    NodeguiPlatformLocation.prototype.href;
    /** @type {?} */
    NodeguiPlatformLocation.prototype.port;
    /** @type {?} */
    NodeguiPlatformLocation.prototype.protocol;
    /**
     * @type {?}
     * @private
     */
    NodeguiPlatformLocation.prototype.locationStrategy;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var NS_ROUTER_PROVIDERS = [
    {
        provide: NodeGuiLocationStrategy,
        useFactory: provideLocationStrategy,
        deps: [[NodeGuiLocationStrategy, new Optional(), new SkipSelf()]]
    },
    { provide: LocationStrategy, useExisting: NodeGuiLocationStrategy },
    NodeguiPlatformLocation,
    { provide: PlatformLocation, useExisting: NodeguiPlatformLocation }
];
var NodeguiRouterModule = /** @class */ (function () {
    function NodeguiRouterModule() {
    }
    /**
     * @param {?} routes
     * @param {?=} config
     * @return {?}
     */
    NodeguiRouterModule.forRoot = /**
     * @param {?} routes
     * @param {?=} config
     * @return {?}
     */
    function (routes, config) {
        return {
            ngModule: NodeguiRouterModule,
            providers: __spread(RouterModule.forRoot(routes, config).providers, NS_ROUTER_PROVIDERS)
        };
    };
    /**
     * @param {?} routes
     * @return {?}
     */
    NodeguiRouterModule.forChild = /**
     * @param {?} routes
     * @return {?}
     */
    function (routes) {
        return {
            ngModule: NodeguiRouterModule,
            providers: RouterModule.forChild(routes).providers
        };
    };
    NodeguiRouterModule.decorators = [
        { type: NgModule, args: [{
                    imports: [RouterModule],
                    exports: [RouterModule],
                    schemas: [NO_ERRORS_SCHEMA]
                },] }
    ];
    return NodeguiRouterModule;
}());
/**
 * @param {?} locationStrategy
 * @return {?}
 */
function provideLocationStrategy(locationStrategy) {
    return locationStrategy ? locationStrategy : new NodeGuiLocationStrategy();
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { HttpFetchBackend, NodeguiErrorHandler, NodeguiLibModule, NodeguiRouterModule, platformNodeguiDynamic, platformNodeguiStatic, provideLocationStrategy, NodeguiSanitizer as ɵa, NodeguiElementSchemaRegistry as ɵb, QWindowService as ɵc, ComponentsMap as ɵd, NodeguiRendererFactory as ɵe, NodeGuiLocationStrategy as ɵf, NodeguiPlatformLocation as ɵg };
//# sourceMappingURL=angular-nodegui.js.map
