import { Renderer2, RendererFactory2, RendererStyleFlags2, RendererType2 } from '@angular/core';
import { QWindowService } from './window';
import { NgComponent } from './components/component';
import { ComponentsMap, NgComponentClass } from './components/components-map';
import { NgView } from './components/view';
export interface ElementReference {
    previous: NgView;
    next: NgView;
}
export declare class NodeguiRendererFactory implements RendererFactory2 {
    private readonly windowService;
    protected renderer: Renderer2;
    constructor(windowService: QWindowService, components: ComponentsMap);
    end(): void;
    createRenderer(hostElement: any, type: RendererType2 | null): Renderer2;
}
export declare class NodeguiRenderer implements Renderer2 {
    private readonly window;
    readonly data: {
        [p: string]: any;
    };
    readonly componentsMap: Map<string, NgComponentClass>;
    destroyNode: ((node: any) => void) | null;
    constructor(window: QWindowService, components: ComponentsMap);
    createElement(name: string, namespace?: string | null): any;
    createText(value: string): any;
    selectRootElement(): any;
    addClass(el: any, name: string): void;
    appendChild(parent: NgComponent, newChild: any): void;
    createComment(value: string): any;
    destroy(): void;
    insertBefore(parent: NgComponent, newChild: any, { previous, next }: ElementReference): void;
    removeChild(parent: NgComponent, oldChild: NgView): void;
    listen(target: any, eventName: string, callback: (event: any) => boolean | void): () => void;
    nextSibling(node: any): ElementReference;
    parentNode(node: any): any;
    removeAttribute(el: NgComponent, name: string, namespace?: string | null): void;
    removeClass(el: NgComponent, name: string): void;
    removeStyle(el: NgComponent, style: string, flags?: RendererStyleFlags2): void;
    setAttribute(el: NgComponent, name: string, value: string, namespace?: string | null): void;
    setProperty(el: NgComponent, name: string, value: any): void;
    setStyle(el: NgComponent, style: string, value: any, flags?: RendererStyleFlags2): void;
    setValue(node: NgComponent, value: string): void;
}
